var navigator = require('navigator');

exports = module.exports = function(global){

(function(global){
	
 'use strict';
	
var isWorker = ('undefined' !== typeof self && 'function' === typeof self.importScripts) ? true : false;

 if ('undefined' === typeof global) {
	 try{
        global = (new Function("return ('undefined'!==typeof self) ? self  : this;")());
	 }catch(e){
		  var global = (new Function("return ('undefined'!==typeof self) ? self  : this;")());
	 }
  }
    
     
    if ('undefined' === typeof global.isWorker) {
        Object.defineProperty(global, 'isWorker', {
            get: function() {
				console.warn('global.isWorker is deprecated, use frdl.worker instead!');
                return isWorker;
            }
        });
    }










   
   if ('undefined' === typeof Window) {	
	 global.Window = global;
   }
	 
    if ('undefined' === typeof window) {
        if (!!console) {
            console.log('No window object present in this thread, try to shim interfaces...');
        }
			global.window = Window;			
    }
    
    if ('undefined' === typeof window.global) {
      Object.defineProperty(window, 'global', {
            get: function() {
                return global;
            }
      });
    }



         if ( 'undefined' === typeof NamedNodeMap) {
			 	try{
                             NamedNodeMap = global.NamedNodeMap = function() {};
					
				}catch(e){
		                var     NamedNodeMap = global.NamedNodeMap = function() {};
	             }				
         }




       if ('undefined' === typeof Node) {
            function Node() {}	
            Node.prototype = {
                toString: function() {
                    return '[object Node]';
                }
            };
            window.Node = node(0, null, Node);
       }


       if ('undefined' === typeof Element) {
            Element = window.Element = node(1, null, Node);
            if ('undefined' === typeof Element.prototype) Element.prototype = {};
            Element.prototype.toString = function() {
                return '[object Element]';
            };
        }
        if ('undefined' === typeof HTMLCollection) {
            function HTMLCollection(arr) {
                for (var i = 0; i < arr.length; i += 1) {
                    this[i] = arr[i];
                }
                Object.defineProperty(this, 'length', {
                    get: function() {
                        return arr.length;
                    }
                });
                Object.defineProperty(this, 'isShim', {
                    get: function() {
                        return true;
                    }
                });
            //    Object.freeze(this);
            }
            HTMLCollection.prototype = {
                item: function(i) {
                    return this[i] != null ? this[i] : null;
                },
                namedItem: function(name) {
                    for (var i = 0; i < this.length; i += 1) {
                        if (this[i].id === name || this[i].name === name) {
                            return this[i];
                        }
                    }
                    return null;
                }
            };
            window.HTMLCollection = HTMLCollection;
        }
        if ('undefined' === typeof DocumentType) {
            function DocumentType() {}
            DocumentType.prototype = {
                name: (!!isWorker) ? 'wdom' : 'html',
                entities: NamedNodeMap,
                notations: NamedNodeMap,
                publicId: (!!isWorker) ? false : '-//W3C//DTD XHTML 1.1//EN',
                systemId: (!!isWorker) ? 'webfan://v.ns.frdl/~/DTD/~' : 'http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd',
                internalSubset: false
            };
            DocumentType.prototype.toString = function() {
                return "<!DOCTYPE " + this.name + (this.publicId) ? ' PUBLIC "' + this.publicId + '"' : '' + (!this.publicId && this.systemId) ? ' SYSTEM' : '' + (this.systemId) ? ' "' + this.systemId + '"' : '' + '>';
            };
            window.DocumentType = node(10, null, DocumentType);
        }
        if ('undefined' === typeof Document) {
            Document = window.Document = node(9, null, Element);
            if (!isWorker) Document.prototype.toString = function() {
                return '[object Document]';
            };
            Document.doctype = DocumentType;
            Document.nodeName = '#document';
        }
        if ('undefined' === typeof NamedNodeMap) {
            NamedNodeMap = window.NamedNodeMap = function() {};
        }
        if ('undefined' === typeof HTMLElement) {
            HTMLElement = window.HTMLElement = node(1, null, Element);
            if (!isWorker) HTMLElement.prototype.toString = function() {
                return '[object HTMLElement]';
            };
            HTMLElement.parentNode = HTMLElement.firstChild = HTMLElement.lastChild = HTMLElement;
        }
        if ('undefined' === typeof document) {
            if (!!console) {
                console.log('No document object present in this thread, try to shim interfaces...');
            }
            document = window.document = global.document = node(9, null, Document);
            document.doctype = node(10, document, DocumentType);
            document.head = document.body = HTMLElement;
            document.ownerDocument = document.documentElement = document;
            document.getElementById = document.createElement = document.createTextNode = function() {
                return HTMLElement;
            };
            document.createDocumentFragment = function() {
                return this;
            };
            document.getElementsByTagName = document.getElementsByClassName = document.querySelector = document.querySelectorAll = function() {
                return [HTMLElement];
            };
            document.getAttribute = document.setAttribute = document.removeAttribute = document.removeChild = document.addEventListener = document.removeEventListener = function() {
                return null;
            };
            document.cloneNode = document.appendChild = function() {
                return this;
            };
			//document.children = new HTMLCollection([HTMLElement]);
			document.children = [HTMLElement];
            document.appendChild = function(child) {
                child.parentNode = this;
                child.parentNode.children[child.parentNode.children.length] = child;
                return child;
            };
            
            document.createEvent = function(ev) {
                return new Event(ev);
            };
            document.readyState = 4;
        }
        if ('undefined' === typeof HTMLElement.ownerDocument) {
            HTMLElement.ownerDocument = document;
        }

   if ('undefined' === typeof self) {	
	 global.self = global;
   }
 	
	if ('undefined' === typeof Navigator) {	
	 global.Navigator = navigator;
   }
	
	if ('undefined' === typeof navigator) {	
	 global.navigator = global.Navigator;
   }
	
function node(type, parent, pNode) {
            if ('undefined' === typeof pNode) var pNode = Node;
            try {
                var N = new pNode;
            } catch (err) {
                var N = pNode;
            }
            var parent = N.parent = N.parentNode = parent || (pNode.parentNode || (pNode.parent || null));
            N.nodeType = type || ((parent && parent.nodeType) ? parent.nodeType : 0);
            return N;
}


}(global));
	
};